<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:import href="preproc_ppACL2"/>

<!-- Modo reverse_processtree: procesado del árbol básico (copia de  -->
<!-- elementos y atributos), llamada a las plantillas normales y -->
<!-- ordenado inverso de eventos. -->

<!-- Movemos los atributos y descendientes el nodo del método -->
<!-- utilizado en la submeta al padre -->
<xsl:template match="script" mode="process-children">

   <xsl:apply-templates select="defun|defthm|thm|encapsulate|local" mode="process-node">
     <xsl:sort select="position()" order="descending"/>
   </xsl:apply-templates>

   <xsl:apply-templates select="*[not(self::defun) 
                              and not(self::defthm) 
                              and not(self::thm) 
                              and not(self::encapsulate)
                              and not(self::local)]"
                        mode="process-node"/>
</xsl:template>

<xsl:template match="encapsulate" mode="process-children">

   <xsl:apply-templates
   select="*[not(self::defun)]
            [not(self::defthm)]
            [not(self::thm)]
            [not(self::local)]
            [not(self::encapsulate)]
	    [following-sibling::*[self::local 
	                          | self::thm 
                                  | self::defthm 
                                  | self::defun 
                                  | self::encapsulate]]"
   mode="process-node"/>

   <xsl:apply-templates select="defun|defthm|thm|encapsulate|local" mode="process-node">
     <xsl:sort select="position()" order="descending"/>
   </xsl:apply-templates>

   <xsl:apply-templates
   select="*[not(self::defun)]
            [not(self::defthm)]
            [not(self::thm)]
            [not(self::local)]
            [not(self::encapsulate)]
	    [preceding-sibling::*[self::local 
	                          | self::thm 
                                  | self::defthm 
                                  | self::defun 
                                  | self::encapsulate]]"
   mode="process-node"/>

</xsl:template>

</xsl:stylesheet>
